// $Id: interfacePointer.cpp,v 1.2 2000/03/27 16:49:22 chuang Exp $
#include <string.h>
#include "interfacePointer.h"

// Copy the pointer to the internal representation.

static void
interfacePointerDupInternalRep (Tcl_Obj *pSrc, Tcl_Obj *pDup)
{
    pDup->internalRep.otherValuePtr = pSrc->internalRep.otherValuePtr;
    pDup->typePtr = pSrc->typePtr;
}

// Set the string representation to match the internal representation.

static void
interfacePointerUpdateString (Tcl_Obj *pObj)
{
    char stringRep[80];

    pObj->length = sprintf(
        stringRep,
        "%ld",
        pObj->internalRep.otherValuePtr);
    pObj->bytes = Tcl_Alloc(pObj->length + 1);
    strcpy(pObj->bytes, stringRep);
}

// Set internal representation from string representation.

static int
interfacePointerSetFromAny (Tcl_Interp *interp, Tcl_Obj *pObj)
{
    char *stringRep = Tcl_GetStringFromObj(pObj, 0);
    ClientData pUnknown;
    if (sscanf(stringRep, "%ld", &pUnknown) != 1) {
	Tcl_AppendResult(interp, "invalid handle ", stringRep, NULL);
        return TCL_ERROR;
    }

    // Free the old internal representation.
    if (pObj->typePtr != NULL && pObj->typePtr->freeIntRepProc != NULL) {
        pObj->typePtr->freeIntRepProc(pObj);
    }

    pObj->typePtr = &interfacePointerObjType;
    pObj->internalRep.otherValuePtr = pUnknown;
    return TCL_OK;
}

Tcl_ObjType interfacePointerObjType = {
    "tcomInterfacePointer",
    NULL,
    interfacePointerDupInternalRep,
    interfacePointerUpdateString,
    interfacePointerSetFromAny
};
