// $Id: releaseCmd.cpp,v 1.10 2000/03/27 16:49:22 chuang Exp $
#include "refCmd.h"
#include "infoCmd.h"
#include "typelibCmd.h"
#include "releaseCmd.h"

// This Tcl command frees the resources used by an opaque handle.

int
releaseCmd (
    ClientData clientData,	/* Not used. */
    Tcl_Interp *interp,		/* Current interpreter. */
    int objc,			/* Number of arguments. */
    Tcl_Obj *CONST objv[])	/* The argument objects. */
{
    if (objc < 2) {
	Tcl_WrongNumArgs(interp, 1, objv, "handle ?handle ...?");
	return TCL_ERROR;
    }

    for (int i = 1; i < objc; ++i) {
        Tcl_Obj *pObj = objv[i];

        if (HandleSupport<Reference>::instance(interp).count(pObj)) {
            HandleSupport<Reference> &referenceHandleSupport =
                HandleSupport<Reference>::instance(interp);
            Reference *pRef = referenceHandleSupport.find(pObj);
            ReferenceFactory::instance().destroy(pRef);
            referenceHandleSupport.erase(pObj);

        } else if (HandleSupport<Interface>::instance(interp).count(pObj)) {
            HandleSupport<Interface>::instance(interp).erase(pObj);

        } else if (HandleSupport<TypeLib>::instance(interp).count(pObj)) {
            HandleSupport<TypeLib> &typeLibHandleSupport =
                HandleSupport<TypeLib>::instance(interp);
            TypeLib *pTypeLib = typeLibHandleSupport.find(pObj);
            delete pTypeLib;
            typeLibHandleSupport.erase(pObj);

        } else {
            char *arg = Tcl_GetStringFromObj(pObj, 0);
            Tcl_AppendResult(interp, "invalid argument ", arg, NULL);
            return TCL_ERROR;
        }
    }
    return TCL_OK;
}
